<?php

	/*----------------------------------------------------------------------------------------
 	乐智大转盘 DISCUZ 插件接口  2014-8-15  乐智软件 www.lezhi99.com  版权所有
	----------------------------------------------------------------------------------------*/

	//这边使用wl是为了防止函数名与其他插件冲突的
	class LZ{

		/**
		 * 获取语言包内容
		 * @param  [string] $langID   语言包ID
		 * @param  [array]  $variable 语言包动态变量值，数组格式
		 * @return [string]           对应语言的文本内容
		 */
		static function lang($langID,$variable){
			$strs = lang('plugin/lezhi99_lottery',$langID);
			if($variable){
				foreach ($variable as $k=>$v) { $strs = str_replace('{'.$k.'}',$v,$strs); }
			}
			return $strs;
		}

		/**
		 * 获取用户输入变量
		 * @param [string] $name    变量的名称 支持指定类型，格式如：get.name
		 * @param [string] $filter  指定过滤参数的函数,默认使用addslashes过滤
		 * @param [string] $default 变量为空时的默认值
		 * @return [string]         指定的参数值
		 */
		static function input($name,$filter='addslashes',$default){
			$filter=='int' && $filter='intval';
		    //获得参数值
		    $temArr = explode('.',$name);
		    if($temArr[1]){
			    switch($temArr[0]){
	        		case 'get'  : $data = $_GET[$temArr[1]]; break;
	        		case 'post' : $data = $_POST[$temArr[1]]; break;
			    }
	        }else{
			    switch($temArr[0]){
	        		case 'get'  : $data = $_GET; break;
	        		case 'post' : $data = $_POST; break;
			    }
	        }
		    //设置默认值
		    !$data && $data=$default;
		    //过滤参数，默认使用 addslashes 过滤
		    if(is_array($data)){
		    	foreach ($data as $k => $v) { $data[$k] = $filter($v); }
		    }else{
				$data = $filter($data);
		    }
		    return $data;
		}

		/**
		 * 返回插件使用的表格名称
		 * @param  [string] $_table 表格名称
		 * @param  [string] $_all   是否返回完整的表格名称，包含数据库前缀
		 * @return [string]         表格名
		 */
		static function table($_table,$_all){
			if($_all==true){
				return DB::table('plugin_lezhi99_lottery_').$_table;
			}else{
				return 'plugin_lezhi99_lottery_'.$_table;
			}
		}

		/**
		 * 传入sql，返回数组列表。
		 * @param  [string] $_sqlstr SQL查询语句
		 * @return [array]           结果数组
		 */
		static function getList($_sqlstr){
			$list = DB::query($_sqlstr);
			$results = array();
			while($result = DB::fetch($list)) {
				$results[] = $result;
			}
			return $results;
		}

		/**
		 * 获取数据条数
		 * @param  [string] $_table 数据表名称（不包含前缀）
		 * @param  [string] $_where 条件语句
		 * @return [int]            记录条数
		 */
		static function getCount($_table,$_where){
			if ($_where!=''){
				$zhi =  DB::result_first('SELECT count(*) FROM '.LZ::table($_table,true).' where '.$_where);
			}else{
				$zhi =  DB::result_first('SELECT count(*) FROM '.LZ::table($_table,true));
			}
			return $zhi;
		}

		/**
		 * 获取缓存变量
		 * @param  [string] $_name 名称
		 * @return [object]        缓存值
		 */
		static function getCache($_name){
			global $_G;
			return $_G['cache']['plugin']['lezhi99_lottery'][$_name];
		}

		/**
		 * 获取积分名称
		 * @param  [string] $_name 积分标识
		 * @return [string]        对应积分的名称
		 */
		static function getExtcreditsName($_name){
			global $_G;
			return $_G['setting']['extcredits'][$_name]['title'];
		}

		/**
		 * 转换后台地址
		 * @param  [string] $_model 文件模型（admin_之后的字符串）
		 * @param  [string] $_view  所属视图
		 * @param  [string] $_heads 访问方式
		 * @return [string]         返回一个URL
		 */
		static function getAdminUrl($_model,$_view,$_heads){
			global $pluginid;
			if ($_heads=='cpmsg'){
				return 'action=plugins&operation=config&do='.$pluginid.'&identifier=lezhi99_lottery&pmod=admin_'.$_model.'&view='.$_view;
			}elseif($_heads=='form'){
				return 'plugins&operation=config&do='.$pluginid.'&identifier=lezhi99_lottery&pmod=admin_'.$_model.'&view='.$_view;
			}else{
				return 'admin.php?action=plugins&operation=config&do='.$pluginid.'&identifier=lezhi99_lottery&pmod=admin_'.$_model.'&view='.$_view;
			}
		}

		/**
		 * 获取已启用的积分列表
		 * @return [array] 返回一个数组，包含一启用的积分列表。
		 */
		static function getExtcreditsList(){
			global $_G;
			foreach ($_G['setting']['extcredits'] as $k => $v) {
				$list[] = array('id'=>$k,'name'=>$v['title']);
			}
			return $list;
		}

		/**
		 * 获取插件自定义配置信息
		 * @param  [string] $type 配置类型
		 * @return [array]        返回配置信息
		 */
		static function getLotteryConfig($type){
			//读取信息
			$info = DB::fetch_first('SELECT '.$type.'_config FROM '.LZ::table('config',true).' where id=1');
			//返回列表（经过进行json解析后的数组）
			return json_decode($info[$type.'_config'],true);
		}

		/**
		 * 保存插件自定义配置信息
		 * @param  [string] $type 配置类型
		 * @param  [array]  $list 配置内容（数组）
		 * @param  [string] $sort 是否进行排序
		 */
		static function saveLotteryConfig($type,$list,$sort='sort'){
			//根据数组的第一个值（order）进行排序
			if($sort=='sort'){ sort($list); }
			//保存数据
			DB::update(LZ::table('config'),array($type.'_config' => json_encode($list),),'id=1');
		}

		/**
		 * 获取指定用户的扩展积分信息
		 * @param  [int] $uid 用户UID
		 * @param  [int] $exp 扩展积分标识ID
		 * @return [int]      返回用户剩余积分
		 */
		static function getMemberExtcredits($uid,$exp){
			$info = DB::fetch_first('SELECT extcredits'.(int)$exp.' FROM '.DB::table('common_member_count').' where uid='.(int)$uid);
			return $info['extcredits'.$exp];
		}

		/**
		 * 获得当前登陆用户的签到信息
		 * @return [array] 返回签到信息
		 */
		static function getSignInfo(){
			//获得用户签到信息
			global $_G;
			$uid = (int)$_G['uid'];
			$signInfo = DB::fetch_first('SELECT * FROM '.LZ::table('sign','all').' where uid='.(int)$uid);
			if(!$signInfo){	//没有记录，则初始化一个数据
				$signInfo=array(
					'uid'				=> $uid,
					'sign_count'		=> 0,
					'sign_continuous'	=> 0,
					'last_sign'			=> 0,
				);
			}
			$yesterdayTime = strtotime(date('Y-m-d',strtotime('-1 day')));
			//若最后签到在昨天以前，则连续签到天数为0天
			if($signInfo['last_sign']<$yesterdayTime){ $signInfo['sign_continuous']=0; }
			return $signInfo;
		}

		//实例化Label类
		static function label(){
			require_once DISCUZ_ROOT.'/source/plugin/lezhi99_lottery/include/label.php';
			return new lezhiLabel();		//实例化Label类
		}

		//获取不重复种子，用于对配置一些参数进行识别
		static function getSeeds(){
			$info = DB::fetch_first('SELECT seeds FROM '.LZ::table('config','all').' where id=1');
			DB::query('update '.LZ::table('config','all').' set seeds=seeds+1 where id=1');
			return $info['seeds'];
		}

		/**
		 * 与云端插件API通讯
		 * @param  [string] $apiName API名称
		 * @param  [array]  $params  需要传递的参数
		 * @return [object]          成功则返回一个数组，包含API反馈的信息，否则返回一个字符串，输出错误提示
		 */
		static function ping($apiName,$params){
			//获取插件参数
			loadcache('plugin');	//导入插件缓存
			$api_key = LZ::getCache('api_key');
			$api_url = LZ::getCache('api_url');
			$wid = substr($api_key,0,9);
			if(!$api_key || !$api_url){ return LZ::lang('api_ping_error'); }
			//拼接参数代码
			$params['api']  = $apiName;
			$params['wid']  = $wid;
			$params['time'] = time();
			//参数编码转换为utf8格式
			$params = LZ::to_utf8($params);
			foreach ($params as $k=>$v){ $params_str .="{$k}={$v}&"; }
			//生成KEY
			sort($params,SORT_STRING);
			$key = md5($api_key.implode('', $params));
			//拼接URL
			$url = $api_url."Api-{$apiName}?{$params_str}key={$key}";
			$data = file_get_contents($url);
			$data = json_decode($data,true);
			if($data){
				$data = LZ::to_current_coding($data);
				if($data['state']=='error'){
					return 'API '.$apiName.' error:'.$data['error'];
				}else{
					return $data;
				}
			}else{
				return 'API '.$apiName.' error:An unknown error.';
			}
		}

		/**
		 * 字符串加密（可逆）
		 * @param  [type] $string 需要加密的字符串
		 * @return [type]         字符串加密后的密文
		 */
		static function strEn($string){
			$key='lezhi99';
			$string = base64_encode($string);
			$len = strlen($key);
			$code = '';
			for($i=0; $i<strlen($string);$i++){
				$k= $i % $len;
				$code.= $string[$i] ^ $key[$k];
			}
			return base64_encode($code);
		}

		/**
		 * 解密由strEn加密的字符串
		 * @param  [string] $string 加密后的密文
		 * @return [string]         解密后的明文字符串
		 */
		static function strDe($string){
			$key='lezhi99';
			$string = base64_decode($string);
			$len = strlen($key);
			$code = '';
			for($i=0; $i<strlen($string);$i++){
				$k= $i % $len;
				$code.= $string[$i] ^ $key[$k];
			}
			return base64_decode($code);
		}

		//用户签到提交操作，在 lezhi99_lottery.inc.php 中调用
		static function userSign(){
			//获取插件参数
			loadcache('plugin');	//导入插件缓存
			$sign_state = LZ::getCache('sign_state');
			if(!$sign_state){
				$tipType = 'error';
				$tipHtml = LZ::lang('index_sign_error_notopen');
				$tipButton = '<button type="button" onclick="hideWindow(\'sign\');" name="cames" class="pn" value="1"><strong>'.LZ::lang('index_sign_affirm_text').'</strong></button>';
			}else{
				//获得用户签到信息
				$signInfo = LZ::getSignInfo();
				//获得相关时间戳
				$todayTime = strtotime(date('Y-m-d'));
				if($signInfo['last_sign']<$todayTime){
					//获得缓存变量
					global $_G;
					$awardNum = LZ::getCache('sign_num');
					$signSpecial = explode("\r\n", LZ::getCache('sign_special'));
					//检查是否有特殊奖励
					foreach ($signSpecial as $v){
						$temArr = explode('=', $v);
						if(strpos($temArr[0],'+')){
							$temArr[0] = str_replace('+','',$temArr[0]);
							if(($signInfo['sign_continuous']+1)>=trim($temArr[0])){$awardNum = trim($temArr[1]);}
							break;
						}
						if(($signInfo['sign_continuous']+1)==trim($temArr[0])){
							$awardNum = trim($temArr[1]);
							break;
						}
					}
					//发放抽奖机会
					$state = LZ::ping('add_user_num',array(
						'uid'		 => $_G['uid'],
						'username'	 => $_G['username'],
						'groups'	 => $_G['groupid'],
						'explain'	 => 'sign '.($signInfo['sign_continuous']+1).' day',
						'avatar_url' => str_replace(array('/','+'), array('!','@'), base64_encode('http://'.$_SERVER['HTTP_HOST'].'/uc_server/avatar.php?uid='.$_G['uid'])),
						'num' 		 => $awardNum,
					));
					//抽奖机会增加成功，才进行签到操作
					if(is_array($state)){
						//更新签到信息
						$signInfo['sign_count']++;
						$signInfo['sign_continuous']++;
						$signInfo['last_sign']=$todayTime;
						if($signInfo['sign_count']==1){	//第1次签到，新建签到记录。
							DB::insert(LZ::table('sign'),$signInfo);
						}else{
							DB::update(LZ::table('sign'),$signInfo,'uid='.$signInfo['uid']);
						}
						//设置提示信息
						$hideLinkJs = "document.getElementById('signLink').style.color='#bbb';document.getElementById('signLink').innerHTML='".LZ::lang('index_sign_havelink_text')."';document.getElementById('signLink').title='".LZ::lang('index_sign_link_text',array('signCount'=>$signInfo['sign_count'],'signContinuous'=>$signInfo['sign_continuous']))."';";
						$tipType = 'right';
						$tipHtml = LZ::lang('index_sign_succeed_tip',array(
							'signCount'			=> $signInfo['sign_count'],
							'signContinuous'	=> $signInfo['sign_continuous'],
							'awardNum'			=> $awardNum,
						));
						$tipButton = '
							<button type="button" onclick="window.open(\'plugin.php?id=lezhi99_lottery\');hideWindow(\'sign\');'.$hideLinkJs.'" name="sendbut" class="pn pnc" value="1"><strong>'.LZ::lang('index_sign_to_lottery').'</strong></button>
							<button type="button" onclick="hideWindow(\'sign\');'.$hideLinkJs.'" name="cames" class="pn" value="1"><strong>'.LZ::lang('index_sign_to_close').'</strong></button>
						';
					}else{
						$tipType = 'error';
						$tipHtml = LZ::lang('index_sign_error').'<br/>'.$state;
						$tipButton = '<button type="button" onclick="hideWindow(\'sign\');" name="cames" class="pn" value="1"><strong>'.LZ::lang('index_sign_affirm_text').'</strong></button>';
					}
				}else{	//已经签到过了
					$hideLinkJs = '';
					$tipType = 'info';
					$tipHtml = LZ::lang('index_sign_have_tip',array(
						'signCount'			=> $signInfo['sign_count'],
						'signContinuous'	=> $signInfo['sign_continuous'],
					));
					$tipButton = '
						<button type="button" onclick="window.open(\'plugin.php?id=lezhi99_lottery\');hideWindow(\'sign\');'.$hideLinkJs.'" name="sendbut" class="pn pnc" value="1"><strong>'.LZ::lang('index_sign_to_lottery').'</strong></button>
						<button type="button" onclick="hideWindow(\'sign\');'.$hideLinkJs.'" name="cames" class="pn" value="1"><strong>'.LZ::lang('index_sign_affirm_text').'</strong></button>
					';
				}
			}
			//输出提示HTML代码
			$html = '
				<input type="hidden" value=":">
				<h3 class="flb">
					<em>'.LZ::lang('index_sign_affirm_title').'</em>
					<span>
						<a href="javascript:void(0);" class="flbc" onclick="hideWindow(\'sign\');'.$hideLinkJs.'">'.LZ::lang('index_sign_close_text').'</a>
					</span>
				</h3>
				<div class="c altw">
					<div class="alert_'.$tipType.'">'.$tipHtml.'</div>
				</div>
				<p class="o pns">'.$tipButton.'</p>
			';
			//返回HTML代码
			return $html;
		}

	    //将字符串转换为utf8编码
	    static function to_utf8($variable,$coding='GBK'){
	    	$coding = mb_detect_encoding(LZ::lang('ck_encoding_text'),array('UTF-8','GBK','BIG5'));
	    	if($coding!='UTF-8'){
	    		if(is_array($variable)){
	    			foreach($variable as $k=>$v) { $variable[$k] = LZ::to_utf8($v); }
	    		}else{
	    			$variable = iconv($coding,'UTF-8//IGNORE',$variable);
	    		}
	    	}
	    	return $variable;
	    }

	    //将字符串转换为当前文件编码
	    static function to_current_coding($variable,$coding='GBK'){
	    	$coding = mb_detect_encoding(LZ::lang('ck_encoding_text'),array('UTF-8','GBK','BIG5'));
	    	if($coding!='UTF-8'){
	    		if(is_array($variable)){
	    			foreach($variable as $k=>$v) { $variable[$k] = LZ::to_current_coding($v); }
	    		}else{
	    			$variable = iconv('UTF-8//IGNORE',$coding,$variable);
	    		}
	    	}
	    	return $variable;
	    }

	}
?>